﻿Imports System
Imports System.IO
Imports System.Threading
Imports System.Runtime.Serialization
Imports System.Runtime.Serialization.Formatters.Binary
Imports System.Windows.Forms


'PCR-Program Clock Reference
'PTS-Presentation Time Stamp
'DTS
Public Class Form1
    Delegate Sub GetInfoFromFileThreadDelegate(ByVal c As Int32)
    Private GetInfoFromFileThreadInstance As New GetInfoFromFileThreadDelegate(AddressOf getInfoFromFileThread)
    Delegate Sub TimeKeepThreadDelegate(ByVal c As Int32)
    Private TimeKeepThreadInstance As New TimeKeepThreadDelegate(AddressOf TimeKeepThread)
    Delegate Sub WriteButton2TextDelegate(ByVal Value As String)
    Private WriteButton2TextInstance As New WriteButton2TextDelegate(AddressOf WriteButton2Text)
    Delegate Sub WriteDataGridView2Delegate(ByVal i As Int32, ByVal Value As String)
    Private WriteDataGridView2Instance As New WriteDataGridView2Delegate(AddressOf WriteDataGridView2)
    Delegate Sub ForeColorDataGridView2Delegate(ByVal c As Int32, ByVal Value As System.Drawing.Color)
    Private ForeColorDataGridView2Instance As New ForeColorDataGridView2Delegate(AddressOf ForeColorDataGridView2)
    'PTSとPCRの同期 PTSが先にくる PCRはPTSより小さい
    'PTSをAM01:00:00からにPTS=324000000
    Private Const startVideoPTS As Long = 324000000L
    Private Const DataGriedViewColum0Width = 362
    Private Const DataGriedViewColum1Width = 112
    Private Const DataGriedViewColum2Width = 76
    Private Const DataGriedViewColum3Width = 76
    Private Const DataGriedViewScrollBWidth = 20

    Private srcFileName As String
    Private dstFileName As String
    Private _sorder As Int32 = 0
    Private bForcedEnding As Boolean
    Private bIsExecute As Boolean

    Private nVideo(&H177FFF) As Byte     ' データ格納用配列188X8192
    Private nBuffPoint As Long
    Private nFilePoint As Long
    Private readSize As Int32            ' Readメソッドで読み込んだバイト数
    Private rfs As FileStream
    Private ofs As FileStream
    '----------------------------------------------------------------------
    Private bPAT As Boolean
    Private bPMT As Boolean
    Private bPCRPID As Boolean
    Private bVideoPID As Boolean
    Private bAudioPID As Boolean
    Private bGOP As Boolean
    Private PMT_PID As Int32
    Private PCR_PID As Int32
    Private Video_PID As Int32
    Private Audio_PID As Int32
    Private VideoStreamID As Int32 = -1
    Private AudioStreamID As Int32 = -1
    '----------------------------------------------------------------------
    'フォルダ選択
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim srcPath2 As String = SelectFolder(Me, srcPath)
        If String.IsNullOrEmpty(srcPath2) Then Exit Sub
        Dim files As String() = System.IO.Directory.GetFiles(srcPath2, "*.ts", System.IO.SearchOption.TopDirectoryOnly)
        'DataGridView1ファイル名追加
        'DataGridView2ファイル名追加
        Me.DataGridView1.Rows.Clear()
        Me.DataGridView2.Rows.Clear()
        Dim fileI As String
        Dim i As Int32 = 0
        For Each fileI In files
            If Path.GetExtension(fileI).ToLower = ".ts" Then
                setFilesToDataGridView(i, fileI)
                i += 1
            End If
        Next
        If Me.DataGridView1.RowCount < 20 Then
            Me.DataGridView1.RowCount = 20
            Me.DataGridView2.RowCount = 20
        End If

        Me.DataGridView1.ClearSelection()
        Me.DataGridView2.ClearSelection()

    End Sub

    'ファイル
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim files As String() = SelectFiles(srcPath)
        If files Is Nothing Then Exit Sub
        Dim fileI As String

        'DataGridView1ファイル名追加
        'DataGridView2ファイル名追加
        Me.DataGridView1.Rows.Clear()
        Me.DataGridView2.Rows.Clear()
        Dim i As Int32 = 0
        For Each fileI In files
            If Path.GetExtension(fileI).ToLower = ".ts" Then
                setFilesToDataGridView(i, fileI)
                i += 1
            End If
        Next
        If Me.DataGridView1.RowCount < 20 Then
            Me.DataGridView1.RowCount = 20
            Me.DataGridView2.RowCount = 20
        End If

        Me.DataGridView1.ClearSelection()
        Me.DataGridView2.ClearSelection()

    End Sub

    '全クリア
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click

        For i As Int32 = 0 To Me.DataGridView1.RowCount - 2
            Me.DataGridView1.Rows.RemoveAt(0)
            Me.DataGridView2.Rows.RemoveAt(0)
        Next

        Me.DataGridView1.Columns(0).Width = Me.DataGridView1.Width - Me.DataGridView1.Columns(1).Width - DataGriedViewScrollBWidth
        Me.DataGridView2.Columns(1).Width = DataGriedViewColum1Width
        Dim nWidth As Int32 = Me.DataGridView2.Width - DataGriedViewColum1Width - DataGriedViewColum2Width - DataGriedViewColum3Width - DataGriedViewScrollBWidth
        If nWidth < DataGriedViewColum0Width Then
            Me.DataGridView2.Columns(0).Width = DataGriedViewColum0Width
        Else
            Me.DataGridView2.Columns(0).Width = nWidth
        End If
        Me.DataGridView1.RowCount = 20
        Me.DataGridView2.RowCount = 20
        Me.DataGridView1.ClearSelection()
        Me.DataGridView2.ClearSelection()

    End Sub

    '選択クリア
    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Dim dgv1 As DataGridView = Me.DataGridView1
        Dim dgv2 As DataGridView = Me.DataGridView2
        If dgv1.SelectedRows.Count < 1 Then Exit Sub

        Dim r As DataGridViewRow
        For Each r In dgv1.SelectedRows
            If Not r.IsNewRow Then
                dgv2.Rows.RemoveAt(r.Index)
                dgv1.Rows.Remove(r)
            End If
        Next r
        Dim g As Graphics = Graphics.FromHwnd(Me.DataGridView1.Handle)
        Dim sf As New StringFormat()
        Dim VItemWidth As Int32
        Dim V1Item0Width As Int32 = DataGriedViewColum0Width
        Dim V2Item0Width As Int32 = DataGriedViewColum0Width
        Dim V2Item1Width As Int32 = DataGriedViewColum1Width
        For i As Int32 = 0 To Me.DataGridView1.Rows.Count - 1
            VItemWidth = CInt(g.MeasureString(dgv1(0, i).Value, dgv1.Font, Integer.MaxValue, sf).Width)
            If V1Item0Width < VItemWidth Then V1Item0Width = VItemWidth
            VItemWidth = CInt(g.MeasureString(dgv2(0, i).Value, dgv2.Font, Integer.MaxValue, sf).Width)
            If V2Item0Width < VItemWidth Then V2Item0Width = VItemWidth
            VItemWidth = CInt(g.MeasureString(dgv2(1, i).Value, dgv2.Font, Integer.MaxValue, sf).Width)
            If V2Item1Width < VItemWidth Then V2Item1Width = VItemWidth
        Next

        If dgv1.Width < dgv1.Columns(0).Width + dgv1.Columns(1).Width + 20 Then
            VItemWidth = dgv1.Width - dgv1.Columns(1).Width - 20
            If V1Item0Width < VItemWidth Then
                dgv1.Columns(0).Width = VItemWidth
            End If
        End If
        If dgv2.Width < dgv2.Columns(0).Width + dgv2.Columns(1).Width + dgv2.Columns(2).Width + dgv2.Columns(3).Width + 20 Then
            'Column1
            VItemWidth = dgv2.Width - dgv2.Columns(0).Width - dgv2.Columns(2).Width - dgv2.Columns(3).Width - 20
            If V2Item1Width < VItemWidth Then
                dgv2.Columns(1).Width = VItemWidth
            Else
                dgv2.Columns(1).Width = V2Item1Width
            End If
            'Column0
            VItemWidth = dgv2.Width - dgv2.Columns(1).Width - dgv2.Columns(2).Width - dgv2.Columns(3).Width - 20
            If V2Item0Width < VItemWidth Then
                dgv2.Columns(0).Width = VItemWidth
            Else
                dgv2.Columns(0).Width = V2Item0Width
            End If

        End If
        If dgv1.RowCount < 20 Then
            dgv1.RowCount = 20
            dgv2.RowCount = 20
        End If
        dgv1.ClearSelection()
        dgv2.ClearSelection()

    End Sub

    '開始
    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        If bIsExecute = True Then Exit Sub
        bIsExecute = True
        Me.Button1.Enabled = False
        Me.Button2.Enabled = False
        Me.Button4.Enabled = False
        Me.Button3.Enabled = False
        bForcedEnding = False

        Dim g As Graphics = Graphics.FromHwnd(Me.DataGridView1.Handle)
        Dim sf As New StringFormat()
        Dim ItemWidth As Int32
        Dim sTmp As String
        For i As Int32 = 0 To Me.DataGridView1.RowCount - 1
            If (Not String.IsNullOrEmpty(Me.DataGridView1(0, i).Value)) And (Not String.IsNullOrEmpty(Path.GetDirectoryName(Me.DataGridView2(0, i).Value))) Then
                srcFileName = Me.DataGridView1(0, i).Value
                dstFileName = Me.DataGridView2(0, i).Value
                If 0 < i Then
                    Me.DataGridView1.Rows(i - 1).Selected = False
                    Me.DataGridView2.Rows(i - 1).Selected = False
                End If
                Me.DataGridView1.Rows(i).Selected = True
                Me.DataGridView2.Rows(i).Selected = True

                'FileからPCR_PID,Video_PID,Audio_PIDを得る
                Me.Button5.ForeColor = Color.DarkRed
                Me.Button5.Image = My.Resources.ajax_loader_2
                Me.DataGridView2(2, i).Value = TimeString
                sTmp = "PAT,PMT,GOP 検索中"
                Me.DataGridView2(1, i).Value = sTmp
                ItemWidth = CInt(g.MeasureString(sTmp, Me.DataGridView1.Font, Integer.MaxValue, sf).Width)
                If Me.DataGridView2.Columns(1).Width < ItemWidth Then Me.DataGridView2.Columns(1).Width = ItemWidth
                'Me.Button4.Text = "検索中"
                'PAT,PMT,GOP検索
                Dim ar As IAsyncResult = GetInfoFromFileThreadInstance.BeginInvoke(i, Nothing, Nothing)
                Do Until ar.IsCompleted
                    System.Threading.Thread.Sleep(1)
                    System.Windows.Forms.Application.DoEvents()
                Loop
                If bForcedEnding Then Exit For
                'Me.DataGridView2(1, i).Value = "検索完了"
                If (bPMT And bGOP) Or (bPCRPID AndAlso bVideoPID AndAlso bAudioPID AndAlso bGOP) Then
                    'PMT or PCR_PID,Video_PID,Audio_PIDが取得できたら
                    sTmp = "PCR,PTS,DTS 変更中"
                    Me.DataGridView2(1, i).Style.ForeColor = Color.Black
                    Me.DataGridView2(1, i).Value = sTmp
                    ItemWidth = CInt(g.MeasureString(sTmp, Me.DataGridView1.Font, Integer.MaxValue, sf).Width)
                    If Me.DataGridView2.Columns(1).Width < ItemWidth Then Me.DataGridView2.Columns(1).Width = ItemWidth
                    Me.Button5.Image = My.Resources.ajax_loader_2
                    'Me.Button4.Text = "変更中"
                    ar = TimeKeepThreadInstance.BeginInvoke(i, Nothing, Nothing)
                    Do Until ar.IsCompleted
                        System.Threading.Thread.Sleep(1)
                        System.Windows.Forms.Application.DoEvents()
                    Loop
                    sTmp = Me.DataGridView2(1, i).Value
                    ItemWidth = CInt(g.MeasureString(sTmp, Me.DataGridView1.Font, Integer.MaxValue, sf).Width)
                    If Me.DataGridView2.Columns(1).Width < ItemWidth Then Me.DataGridView2.Columns(1).Width = ItemWidth
                    If bForcedEnding Then Exit For
                    Me.DataGridView2(1, i).Style.ForeColor = Color.Black
                    Me.DataGridView2(1, i).Value = "処理完了"
                    Me.Button5.Image = Nothing
                    Me.Button5.ForeColor = Color.Black
                    Me.Button5.Text = "開始"
                    Me.DataGridView2(3, i).Value = TimeString
                Else
                    sTmp = Me.DataGridView2(1, i).Value
                    ItemWidth = CInt(g.MeasureString(sTmp, Me.DataGridView1.Font, Integer.MaxValue, sf).Width)
                    If Me.DataGridView2.Columns(1).Width < ItemWidth Then Me.DataGridView2.Columns(1).Width = ItemWidth
                End If

                Me.Button5.Image = Nothing
                Me.Button5.ForeColor = Color.Black
                Me.Button5.Text = "開始"
                Me.DataGridView2(3, i).Value = TimeString

            End If
        Next
        Me.Button5.Image = Nothing
        Me.Button5.ForeColor = Color.Black
        Me.Button5.Text = "開始"
        Me.Button1.Enabled = True
        Me.Button2.Enabled = True
        Me.Button4.Enabled = True
        Me.Button3.Enabled = True
        bIsExecute = False
        Me.DataGridView1.ClearSelection()
        Me.DataGridView2.ClearSelection()

    End Sub

    '強制終了
    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        bForcedEnding = True

    End Sub

    Private Sub DataGridView1_ColumnHeaderMouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellMouseEventArgs) Handles DataGridView1.ColumnHeaderMouseClick
        If bIsExecute Then Exit Sub
        Dim i As Int32
        For i = 0 To Me.DataGridView1.RowCount - 1
            If String.IsNullOrEmpty(Me.DataGridView1(0, i).Value) Then Exit For
        Next
        Me.DataGridView1.RowCount = i + 1

        If _sorder = SortOrder.Ascending Then
            _sorder = SortOrder.Descending
        Else
            _sorder = SortOrder.Ascending
        End If
        DataGridView1.Sort(New CustomComparer(_sorder))

        If Me.DataGridView1.RowCount < 20 Then
            DataGridView1.RowCount = 20
        End If

        Me.DataGridView2.Rows.Clear()
        Me.DataGridView2.RowCount = Me.DataGridView1.RowCount
        setFilesFromDataGriedVew1()
        Me.DataGridView1.ClearSelection()
        Me.DataGridView2.ClearSelection()

    End Sub

    Private Sub DataGridView1_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles DataGridView1.DragDrop
        'コントロール内にドロップされたとき実行される
        'ドロップされたすべてのファイル名を取得する
        Dim files As String() = CType(e.Data.GetData(DataFormats.FileDrop, False), String())

        'DataGridView1ファイル名追加
        'DataGridView2ファイル名追加
        Me.DataGridView1.Rows.Clear()
        Me.DataGridView2.Rows.Clear()
        Dim fileI As String
        Dim i As Int32 = 0
        For Each fileI In files
            If Path.GetExtension(fileI).ToLower = ".ts" Then
                setFilesToDataGridView(i, fileI)
                i += 1
            End If
        Next
        If Me.DataGridView1.RowCount < 20 Then
            Me.DataGridView1.RowCount = 20
            Me.DataGridView2.RowCount = 20
        End If
        Me.DataGridView1.ClearSelection()
        Me.DataGridView2.ClearSelection()

    End Sub

    Private Sub DataGridView1_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles DataGridView1.DragEnter
        'コントロール内にドラッグされたとき実行される
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            e.Effect = DragDropEffects.Copy
        Else
            e.Effect = DragDropEffects.None
        End If

    End Sub

    Private Sub Form1_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles Me.DragDrop
        'コントロール内にドロップされたとき実行される
        'ドロップされたすべてのファイル名を取得する
        Dim files As String() = CType(e.Data.GetData(DataFormats.FileDrop, False), String())
        'ドロップされたファイルのパスをすべて表示
        Me.DataGridView1.Rows.Clear()
        Me.DataGridView2.Rows.Clear()

        Dim fileI As String
        Dim i As Int32 = 0
        If 0 < files.Length Then
            For Each fileI In files
                If Path.GetExtension(fileI).ToLower = ".ts" Then
                    setFilesToDataGridView(i, fileI)
                    i += 1
                End If
            Next
        End If
        If DataGridView1.RowCount < 20 Then
            Me.DataGridView1.RowCount = 20
            Me.DataGridView2.RowCount = 20
        End If
        Me.DataGridView1.ClearSelection()
        Me.DataGridView2.ClearSelection()

    End Sub

    Private Sub Form1_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles Me.DragEnter
        'コントロール内にドラッグされたとき実行される
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            e.Effect = DragDropEffects.Copy
        Else
            e.Effect = DragDropEffects.None
        End If

    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim fileName As String = Application.StartupPath + "\settings.config"
        If System.IO.File.Exists(fileName) Then
            Dim appSettings As New Settings
            Dim bf2 As New BinaryFormatter
            Dim fs2 As New System.IO.FileStream(fileName, System.IO.FileMode.Open)
            appSettings = CType(bf2.Deserialize(fs2), Settings)
            fs2.Close()
            '変数に設定
            With appSettings
                srcPath = .srcPath
                dstPath = .dstPath
                PATChek = .PATChek
            End With
            appSettings = Nothing
            If Not System.IO.Directory.Exists(System.IO.Path.GetDirectoryName(srcPath)) Then srcPath = ""
            If Not System.IO.Directory.Exists(System.IO.Path.GetDirectoryName(dstPath)) Then dstPath = ""
        Else
            srcPath = ""
            dstPath = ""
            PATChek = True
        End If

        'ドロップされたファイルのパスをすべて表示
        Me.DataGridView1.DefaultCellStyle.SelectionBackColor = SystemColors.InactiveCaption
        Me.DataGridView2.DefaultCellStyle.SelectionBackColor = SystemColors.InactiveCaption
        Me.DataGridView1.DefaultCellStyle.SelectionForeColor = Color.Black
        Me.DataGridView2.DefaultCellStyle.SelectionForeColor = Color.Black
        Me.DataGridView1.Rows.Clear()
        Me.DataGridView2.Rows.Clear()

        Dim cmds As String() = System.Environment.GetCommandLineArgs()
        Dim fileI As String
        Dim i As Int32 = 0
        Dim j As Int32 = 0
        If 1 < cmds.Length Then
            For Each fileI In cmds
                If 0 < i Then
                    If Path.GetExtension(fileI).ToLower = ".ts" Then
                        setFilesToDataGridView(j, fileI)
                        j += 1
                    End If
                End If
                i += 1
            Next

        End If
        If DataGridView1.RowCount < 20 Then
            Me.DataGridView1.RowCount = 20
            Me.DataGridView2.RowCount = 20
        End If
        Me.DataGridView1.ClearSelection()
        Me.DataGridView2.ClearSelection()

    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        Me.ResizeRedraw = False
        If 597 < Me.Width Then
            Dim xx As Int32 = Me.Width - Me.DataGridView1.Width - (597 - 494)
            'DataGridView
            Me.DataGridView1.Width += xx
            Me.DataGridView2.Width += xx
            If DataGriedViewColum0Width < Me.DataGridView1.Width - (DataGriedViewColum1Width + DataGriedViewScrollBWidth) Then
                Me.DataGridView1.Columns(0).Width = Me.DataGridView1.Width - DataGriedViewColum1Width - DataGriedViewScrollBWidth
            End If
            If DataGriedViewColum0Width < Me.DataGridView2.Width - (Me.DataGridView2.Columns(1).Width + DataGriedViewColum2Width + DataGriedViewColum3Width + DataGriedViewScrollBWidth) Then
                Me.DataGridView2.Columns(0).Width = Me.DataGridView2.Width - (Me.DataGridView2.Columns(1).Width + Me.DataGridView2.Columns(2).Width + Me.DataGridView2.Columns(3).Width + DataGriedViewScrollBWidth)
            End If
            'Button
            Me.Button1.Left += xx
            Me.Button2.Left += xx
            Me.Button3.Left += xx
            Me.Button4.Left += xx
            Me.Button5.Left += xx
        End If
        If 496 < Me.Height Then
            Dim yy As Int32 = (Me.Height - Me.DataGridView1.Height - Me.DataGridView2.Height - (496 - 175 * 2)) \ 2
            'DataGrid
            Me.DataGridView1.Height += yy
            Me.DataGridView2.Top += yy
            Me.DataGridView2.Height += yy
            'label
            Me.Label2.Top += yy
            'Button
            Me.Button3.Top += yy
            Me.Button4.Top += yy
            Me.Button5.Top += yy * 2
            Me.Button6.Top += yy * 2
        End If
        Me.ResizeRedraw = True

    End Sub

    Private Sub 入出力設定ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles 入出力設定ToolStripMenuItem.Click
        If bIsExecute Then Exit Sub
        Dim fm As New Form2
        Dim prevsrcPath As String = srcPath
        Dim prevdstPath As String = dstPath
        fm.ShowDialog(Me)
        fm.Dispose()
        If Not prevsrcPath = srcPath Then
            '全クリア
            Button3_Click(sender, e)
        End If
        If Not prevdstPath = dstPath Then
            setFilesFromDataGriedVew1()
            Me.DataGridView1.ClearSelection()
            Me.DataGridView2.ClearSelection()
        End If

    End Sub

    Private Sub PATテーブルチェックToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PATテーブルチェックToolStripMenuItem.Click
        If bIsExecute Then Exit Sub
        Dim fm As New Form3
        fm.ShowDialog(Me)
        fm.Dispose()

    End Sub

    Private Sub バージョン情報ToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles バージョン情報ToolStripMenuItem.Click
        MsgBox("    TsTimeKeeper" + vbCrLf + _
               "       Ver2.0.10.3")

    End Sub

    'PAT,PMT検索(PCRPID,VideoPID,AudioPID,GOP
    Private Sub GetInfoFromFileThread(ByVal c As Int32)
        Try
            Dim rfs = New FileStream(srcFileName, FileMode.Open, FileAccess.Read)
            Dim adpBytes As Int32
            Dim nBuffPoint As Long = 0
            Dim listPMD_PID As New List(Of Int32)
            Dim listVideo_PID As New List(Of Int32)
            Dim listAudio_PID As New List(Of Int32)
            Dim x As Int32
            Dim streamID As Int32
            Dim bGOPFirst As Boolean = True
            Dim errMes As Int32 = 0

            bPAT = False
            bPMT = False
            bPCRPID = False
            bVideoPID = False
            bAudioPID = False
            bGOP = False
            VideoStreamID = -1
            AudioStreamID = -1

            listPMD_PID.Clear()
            listVideo_PID.Clear()
            listAudio_PID.Clear()

            nBuffPoint = -188
            nFilePoint = -188
            readSize = rfs.Read(nVideo, 0, nVideo.Length)

            Do While bForcedEnding = False
                Me.Invoke(WriteButton2TextInstance, New Object() {((nFilePoint * 100) \ rfs.Length).ToString + "%"})
                System.Windows.Forms.Application.DoEvents()
                Do
                    nBuffPoint += 188
                    nFilePoint += 188
                    If readSize - 1 < nBuffPoint Then
                        '読込み
                        readSize = rfs.Read(nVideo, 0, nVideo.Length)
                        If 0 = readSize Then
                            Exit Do
                        End If
                        nBuffPoint = 0
                    End If

                    'プログラムPIDが"00"ならPAT(テーブル識別(00)+セクションシンタクス指示(1)+0+11ならPAT)
                    If bPAT = False Then
                        If 0 = (nVideo(nBuffPoint + 1) And &H1F) * &H100 + nVideo(nBuffPoint + 2) AndAlso &HB = nVideo(nBuffPoint + 5) * &H10 + (nVideo(nBuffPoint + 6) And &HF0) \ &H10 Then
                            Dim dataBytes As Int32 = (nVideo(nBuffPoint + 6) And &HF) * &H100 + nVideo(nBuffPoint + 7) - 9
                            Dim OffSet As Int32 = 0
                            Do While OffSet < dataBytes
                                'If nVideo(nBuffPoint + OffSet + 13) * &H100 + nVideo(nBuffPoint + OffSet + 14) <> 0 AndAlso (nVideo(nBuffPoint + OffSet + 15) And &HE0) = &HE0 Then
                                If PATChek Then
                                    If (Not (nVideo(nBuffPoint + OffSet + 13) * &H100 + nVideo(nBuffPoint + OffSet + 14)).Equals(0)) AndAlso (nVideo(nBuffPoint + OffSet + 15) And &HE0) = &HE0 Then
                                        'PMT_PID = (nVideo(nBuffPoint + OffSet + 15) * &H100 + nVideo(nBuffPoint + OffSet + 16)) And &H1FFF
                                        If -1 = listPMD_PID.IndexOf((nVideo(nBuffPoint + OffSet + 15) * &H100 + nVideo(nBuffPoint + OffSet + 16)) And &H1FFF) Then
                                            listPMD_PID.Add((nVideo(nBuffPoint + OffSet + 15) * &H100 + nVideo(nBuffPoint + OffSet + 16)) And &H1FFF)
                                        End If
                                    End If
                                Else
                                    If Not (nVideo(nBuffPoint + OffSet + 13) * &H100 + nVideo(nBuffPoint + OffSet + 14)).Equals(0) Then
                                        'PMT_PID = (nVideo(nBuffPoint + OffSet + 15) * &H100 + nVideo(nBuffPoint + OffSet + 16)) And &H1FFF
                                        If -1 = listPMD_PID.IndexOf((nVideo(nBuffPoint + OffSet + 15) * &H100 + nVideo(nBuffPoint + OffSet + 16)) And &H1FFF) Then
                                            listPMD_PID.Add((nVideo(nBuffPoint + OffSet + 15) * &H100 + nVideo(nBuffPoint + OffSet + 16)) And &H1FFF)
                                        End If
                                    End If
                                End If
                                OffSet += 4
                            Loop
                            bPAT = True
                        End If
                    End If

                    If bPAT Then
                        Select Case listPMD_PID.Count
                            Case 0
                                errMes = 1
                                bPMT = False
                                Exit Do
                            Case 1
                                PMT_PID = listPMD_PID.Item(0)
                            Case Else
                                errMes = 3
                                bPMT = False
                                Exit Do
                        End Select
                    End If

                    ''プログラムPIDがPMT_PID テーブル識別(02)+セクションシンタクス指示(1)+0+11ならPMT
                    If bPMT = False Then
                        If PMT_PID = (nVideo(nBuffPoint + 1) And &H1F) * &H100 + nVideo(nBuffPoint + 2) AndAlso &H2B = nVideo(nBuffPoint + 5) * &H10 + (nVideo(nBuffPoint + 6) And &HF0) \ &H10 Then
                            PCR_PID = (nVideo(nBuffPoint + 13) And &H1F) * &H100 + nVideo(nBuffPoint + 14)
                            bPCRPID = True
                            Dim dataBytes As Int32 = (nVideo(nBuffPoint + 6) And &HF) * &H100 + nVideo(nBuffPoint + 7)
                            Dim offSet As Int32 = (nVideo(nBuffPoint + 15) And &HF) * &H100 + nVideo(nBuffPoint + 16) + 17
                            Do While offSet < dataBytes
                                Select Case nVideo(nBuffPoint + offSet) 'ストリーム形式識別
                                    Case 2      '映像
                                        'Video_PID = (nVideo(nBuffPoint + 1 + offSet) And &H1F) * &H100 + nVideo(nBuffPoint + 2 + offSet)
                                        If -1 = listVideo_PID.IndexOf((nVideo(nBuffPoint + 1 + offSet) And &H1F) * &H100 + nVideo(nBuffPoint + 2 + offSet)) Then
                                            listVideo_PID.Add((nVideo(nBuffPoint + 1 + offSet) And &H1F) * &H100 + nVideo(nBuffPoint + 2 + offSet))
                                        End If
                                    Case &HF    '音声
                                        'Audio_PID = (nVideo(nBuffPoint + 1 + offSet) And &H1F) * &H100 + nVideo(nBuffPoint + 2 + offSet)
                                        If -1 = listAudio_PID.IndexOf((nVideo(nBuffPoint + 1 + offSet) And &H1F) * &H100 + nVideo(nBuffPoint + 2 + offSet)) Then
                                            listAudio_PID.Add((nVideo(nBuffPoint + 1 + offSet) And &H1F) * &H100 + nVideo(nBuffPoint + 2 + offSet))
                                        End If
                                End Select
                                offSet += ((nVideo(nBuffPoint + 3 + offSet) And &HF) * &H100 + nVideo(nBuffPoint + 4 + offSet) + 5)
                            Loop
                            bPMT = True
                            Exit Do
                        End If
                    End If

                    'GOP,VideoPID
                    If nVideo(nBuffPoint) = &H47 Then
                        If 0 < (nVideo(nBuffPoint + 3) And &H10) Then                       'payload exists
                            adpBytes = 0
                            'アダプテーションが入ってるパケットか
                            If (nVideo(nBuffPoint + 3) And &H20) Then
                                adpBytes = nVideo(nBuffPoint + 4) + 1
                            End If
                            'パケットスタートコード(000001)
                            If nVideo(nBuffPoint + adpBytes + 4) = 0 AndAlso nVideo(nBuffPoint + adpBytes + 5) = 0 AndAlso nVideo(nBuffPoint + adpBytes + 6) = 1 AndAlso (nVideo(nBuffPoint + adpBytes + 10) And &HC0) = &H80 Then
                                If 0 < (nVideo(nBuffPoint + adpBytes + 11) And &HC0) Then   'PTS=&H80 DTS=&H40
                                    x = nVideo(nBuffPoint + adpBytes + 13) And &HF0
                                    If x = &H20 Or x = &H30 Then                            'PTS +DTS
                                        x = nVideo(nBuffPoint + adpBytes + 7)               'streamID
                                        streamID = x And &HF
                                        If (x And &HF0) = &HE0 Then
                                            '映像
                                            If VideoStreamID = -1 Then
                                                VideoStreamID = streamID
                                            End If
                                            If VideoStreamID = streamID Then
                                                'Video_PID = (nVideo(nBuffPoint + 1) And &H1F) * &H100 + nVideo(nBuffPoint + 2)
                                                If -1 = listVideo_PID.IndexOf((nVideo(nBuffPoint + 1) And &H1F) * &H100 + nVideo(nBuffPoint + 2)) Then
                                                    listVideo_PID.Add((nVideo(nBuffPoint + 1) And &H1F) * &H100 + nVideo(nBuffPoint + 2))
                                                End If
                                                bVideoPID = True
                                                If 0 < (nVideo(nBuffPoint + adpBytes + 11) And &H40) Then
                                                    bGOP = True
                                                End If
                                                If bGOP = False Then
                                                    bGOPFirst = False
                                                End If
                                                Exit Do
                                            End If
                                        End If
                                    End If
                                End If
                            End If
                        End If
                    End If

                    'Audio_PID
                    If nVideo(nBuffPoint) = &H47 Then
                        If 0 < (nVideo(nBuffPoint + 3) And &H10) Then           'payload exists
                            'アダプテーションが入ってるパケットか
                            adpBytes = 0
                            If (nVideo(nBuffPoint + 3) And &H20) Then
                                adpBytes = nVideo(nBuffPoint + 4) + 1
                            End If
                            'パケットスタートコード(000001)
                            If nVideo(nBuffPoint + adpBytes + 4) = 0 AndAlso nVideo(nBuffPoint + adpBytes + 5) = 0 AndAlso nVideo(nBuffPoint + adpBytes + 6) = 1 AndAlso (nVideo(nBuffPoint + adpBytes + 10) And &HC0) = &H80 Then
                                x = nVideo(nBuffPoint + adpBytes + 7)   'streamID
                                streamID = x And &H1F
                                If (x And &HE0) = &HC0 Then
                                    '音声
                                    If AudioStreamID = -1 Then
                                        AudioStreamID = streamID
                                    End If
                                    If AudioStreamID = streamID Then
                                        ''Audio_PID = (nVideo(nBuffPoint + 1) And &H1F) * &H100 + nVideo(nBuffPoint + 2)
                                        If -1 = listAudio_PID.IndexOf((nVideo(nBuffPoint + 1) And &H1F) * &H100 + nVideo(nBuffPoint + 2)) Then
                                            listAudio_PID.Add((nVideo(nBuffPoint + 1) And &H1F) * &H100 + nVideo(nBuffPoint + 2))
                                        End If
                                        bAudioPID = True
                                        If bGOP = False Then
                                            bGOPFirst = False
                                        End If
                                        Exit Do
                                    End If
                                End If
                            End If
                        End If
                    End If
                Loop While True

                If 0 < errMes Then Exit Do

                If bPAT AndAlso bPMT AndAlso bGOP AndAlso Not VideoStreamID.Equals(-1) AndAlso Not AudioStreamID.Equals(-1) Then
                    If bGOP And bGOPFirst = False Then
                        errMes = 2
                        bGOP = False
                        Exit Do
                    End If
                    Select Case listVideo_PID.Count
                        Case 0
                            errMes = 1
                            bVideoPID = False
                            Exit Do
                        Case 1
                            Video_PID = listVideo_PID.Item(0)
                        Case Else
                            errMes = 3
                            bVideoPID = False
                            Exit Do
                    End Select
                    Select Case listAudio_PID.Count
                        Case 0
                            errMes = 1
                            bAudioPID = False
                            Exit Do
                        Case 1
                            Audio_PID = listAudio_PID.Item(0)
                        Case Else
                            errMes = 3
                            bAudioPID = False
                            Exit Do
                    End Select
                    Exit Do
                End If
                If readSize = 0 Then Exit Do
                If 188 * 32768 < nFilePoint Then '188 * 32768←根拠無し
                    errMes = 3
                    Exit Do
                End If
            Loop

            If bForcedEnding Then
                ForeColorDataGridView2(c, Color.Red)
                Me.Invoke(WriteDataGridView2Instance, New Object() {c, ((nFilePoint * 100) \ rfs.Length).ToString + "%...強制終了"})
                Me.Invoke(WriteButton2TextInstance, New Object() {"終了"})
            Else
                Select Case errMes
                    Case 0
                        Me.Invoke(WriteButton2TextInstance, New Object() {"100%"})
                    Case 1
                        ForeColorDataGridView2(c, Color.Red)
                        Me.Invoke(WriteDataGridView2Instance, New Object() {c, "ファイルが破損している可能性があります...終了します"})
                        Me.Invoke(WriteButton2TextInstance, New Object() {"終了"})
                    Case 2
                        ForeColorDataGridView2(c, Color.Red)
                        Me.Invoke(WriteDataGridView2Instance, New Object() {c, "ファイルの先頭がGOPで区切られていません...終了します"})
                        Me.Invoke(WriteButton2TextInstance, New Object() {"終了"})
                    Case 3
                        ForeColorDataGridView2(c, Color.Red)
                        Me.Invoke(WriteDataGridView2Instance, New Object() {c, "複数の映像が含まれています...処理できません"})
                        Me.Invoke(WriteButton2TextInstance, New Object() {"終了"})
                End Select
            End If

        Catch ex As System.Exception
            Me.Invoke(WriteDataGridView2Instance, New Object() {c, ex.Message})
            Throw
        Finally
            If Not rfs Is Nothing Then
                rfs.Close()
                rfs.Dispose()
            End If

        End Try

    End Sub

    '変更本体
    Private Sub TimeKeepThread(ByVal c As Int32)
        Dim adpBytes As Int32
        Dim foundVideoPTS As Boolean
        Dim foundGOP As Boolean
        Dim numGOP As Long = 0
        Dim nowValuePCR As Long
        Dim setValuePCR As Long
        Dim prevValueGOPPTS As Long
        Dim nowValueGOPPTS As Long
        Dim setValueGOPPTS As Long
        Dim nowValuePTS As Long
        Dim setValuePTS As Long
        Dim nowValueDTS As Long
        Dim setValueDTS As Long
        Dim prevSetValueGOPPTS As Long
        Dim difValueGOPPTSBASE As Long
        Dim prevdifValueGOPPTSBASE As Long
        Dim difValueGOPPTS As Long
        Dim streamID As Int32
        Dim x As Int32

        Try
            rfs = New FileStream(srcFileName, FileMode.Open, FileAccess.Read)
            ofs = New FileStream(dstFileName, FileMode.Create, FileAccess.Write)

            nBuffPoint = -188
            nFilePoint = -188
            '読込み
            readSize = rfs.Read(nVideo, 0, nVideo.Length)

            While bForcedEnding = False
                Me.Invoke(WriteButton2TextInstance, New Object() {((nFilePoint * 100) \ rfs.Length).ToString + "%"})
                System.Windows.Forms.Application.DoEvents()
                Do
                    nBuffPoint += 188
                    nFilePoint += 188
                    If readSize - 1 < nBuffPoint Then
                        '書込み
                        ofs.Write(nVideo, 0, readSize)
                        '読込み
                        readSize = rfs.Read(nVideo, 0, nVideo.Length)
                        If 0 = readSize Then
                            rfs.Close()
                            ofs.Close()
                            rfs.Dispose()
                            ofs.Dispose()
                            Exit Sub
                        End If
                        nBuffPoint = 0
                    End If

                    foundGOP = False
                    foundVideoPTS = False

                    'PCR
                    'If nVideo(nBuffPoint) = &H47 Then
                    'adaptation field exists
                    If 0 < (nVideo(nBuffPoint + 3) And &H20) Then
                        'PCR flag
                        If 0 < (nVideo(nBuffPoint + 5) And &H10) Then
                            x = nVideo(nBuffPoint + 1) And &HE0
                            If x = 0 Or x = &H20 Then
                                If (nVideo(nBuffPoint + 1) And &H1F) * &H100 + nVideo(nBuffPoint + 2) = PCR_PID Then
                                    'PCR設定
                                    'setPCRtoArray(getValuePCR() - difValueGOPPTSBASE * 300)
                                    nowValuePCR = getValuePCR()
                                    setValuePCR = nowValuePCR - difValueGOPPTSBASE * 300
                                    If &H258000000D3L < setValuePCR Then
                                        '&H1FFFFFFFF*300+&H1FF=&H258000000D3
                                        setPCRtoArray(nowValuePCR - prevdifValueGOPPTSBASE * 300, c)
                                    Else
                                        setPCRtoArray(setValuePCR, c)
                                    End If
                                    Exit Do
                                End If
                            End If
                        End If
                    End If
                    'End If

                    '映像PST(GOP)
                    '(nBuffPoint+1)=&H40 payload start 1:Payload starts with first byte of PES Packet
                    '                                  0:No PES Packets in payload 
                    'If nVideo(nBuffPoint) = &H47 Then
                    If (nVideo(nBuffPoint + 1) And &H1F) * &H100 + nVideo(nBuffPoint + 2) = Video_PID Then
                        If 0 < (nVideo(nBuffPoint + 3) And &H10) Then                       'payload exists
                            adpBytes = 0
                            'アダプテーションが入ってるパケットか
                            If (nVideo(nBuffPoint + 3) And &H20) Then
                                adpBytes = nVideo(nBuffPoint + 4) + 1
                            End If
                            'パケットスタートコード(000001)
                            If nVideo(nBuffPoint + adpBytes + 4) = 0 AndAlso nVideo(nBuffPoint + adpBytes + 5) = 0 AndAlso nVideo(nBuffPoint + adpBytes + 6) = 1 AndAlso (nVideo(nBuffPoint + adpBytes + 10) And &HC0) = &H80 Then
                                If 0 < (nVideo(nBuffPoint + adpBytes + 11) And &HC0) Then   'PTS=&H80 DTS=&H40
                                    x = nVideo(nBuffPoint + adpBytes + 13) And &HF0
                                    If x = &H20 Or x = &H30 Then                            'PTS +DTS
                                        x = nVideo(nBuffPoint + adpBytes + 7)               'streamID
                                        streamID = x And &HF
                                        If (x And &HF0) = &HE0 Then
                                            '映像
                                            If VideoStreamID = streamID Then
                                                foundVideoPTS = True
                                                If 0 < (nVideo(nBuffPoint + adpBytes + 11) And &H40) Then
                                                    foundGOP = True
                                                    numGOP += 1
                                                End If
                                                Exit Do
                                            End If
                                        End If
                                    End If
                                End If
                            End If
                        End If
                    End If
                    'End If

                    '音声PTS
                    'If nVideo(nBuffPoint) = &H47 Then
                    If (nVideo(nBuffPoint + 1) And &H1F) * &H100 + nVideo(nBuffPoint + 2) = Audio_PID Then
                        adpBytes = 0
                        'アダプテーションが入ってるパケットか
                        If (nVideo(nBuffPoint + 3) And &H20) Then
                            adpBytes = nVideo(nBuffPoint + 4) + 1
                        End If
                        'パケットスタートコード(000001)
                        If nVideo(nBuffPoint + adpBytes + 4) = 0 AndAlso nVideo(nBuffPoint + adpBytes + 5) = 0 AndAlso nVideo(nBuffPoint + adpBytes + 6) = 1 AndAlso (nVideo(nBuffPoint + adpBytes + 10) And &HC0) = &H80 Then
                            x = nVideo(nBuffPoint + adpBytes + 7)   'streamID
                            streamID = x And &H1F
                            If (x And &HE0) = &HC0 Then
                                '音声
                                If AudioStreamID = streamID Then
                                    '音声PTS設定
                                    'setPTStoArray(adpBytes, getValuePTS(adpBytes) - difValueGOPPTSBASE)
                                    nowValuePTS = getValuePTS(adpBytes)
                                    setValuePTS = nowValuePTS - difValueGOPPTSBASE
                                    If &H1FFFFFFFFL < setValuePTS Then
                                        setPTStoArray(adpBytes, nowValuePTS - prevdifValueGOPPTSBASE, c)
                                    Else
                                        setPTStoArray(adpBytes, setValuePTS, c)
                                    End If
                                    Exit Do
                                End If
                            End If
                        End If
                    End If
                    'End If

                Loop While True

                'PTSの処理(GOP)
                If foundGOP Then
                    Select Case numGOP
                        Case 1 'GOP(PTS)の先頭
                            nowValueGOPPTS = getValuePTS(adpBytes)
                            difValueGOPPTSBASE = nowValueGOPPTS - startVideoPTS
                            prevdifValueGOPPTSBASE = difValueGOPPTSBASE
                            setValueGOPPTS = nowValueGOPPTS - difValueGOPPTSBASE
                            '配列に設定
                            setPTStoArray(adpBytes, setValueGOPPTS, c)
                            prevSetValueGOPPTS = setValueGOPPTS
                            'DTSの設定
                            setDTStoArray(adpBytes, getValueDTS(adpBytes) - difValueGOPPTSBASE, c)
                        Case Else
                            prevValueGOPPTS = nowValueGOPPTS
                            nowValueGOPPTS = getValuePTS(adpBytes)
                            difValueGOPPTS = nowValueGOPPTS - prevValueGOPPTS
                            If difValueGOPPTS < 0 Then                          'ラップアラウンド
                                prevValueGOPPTS = prevValueGOPPTS - &H1FFFFFFFFL
                                difValueGOPPTSBASE = difValueGOPPTSBASE - &H1FFFFFFFFL
                            End If
                            'PTSは90kHzのカウンタなので90000で1秒
                            If 900000 < difValueGOPPTS Then                     'つなぎ目
                                'つなぎめのすぐ後ろのPTS(現在位置)
                                'つなぎ目なので100ms(9009)固定とした
                                setValueGOPPTS = prevSetValueGOPPTS + 9009
                                difValueGOPPTSBASE = nowValueGOPPTS - setValueGOPPTS
                                prevdifValueGOPPTSBASE = difValueGOPPTSBASE
                                setPTStoArray(adpBytes, setValueGOPPTS, c)
                                prevSetValueGOPPTS = setValueGOPPTS
                                'DTSの設定
                                'setDTStoArray(adpBytes, getValueDTS(adpBytes) - difValueGOPPTSBASE)
                                nowValueDTS = getValueDTS(adpBytes)
                                setValueDTS = nowValueDTS - difValueGOPPTSBASE
                                If &H1FFFFFFFFL < setValueDTS Then
                                    setDTStoArray(adpBytes, nowValueDTS - prevdifValueGOPPTSBASE, c)
                                Else
                                    setDTStoArray(adpBytes, setValueDTS, c)
                                End If
                            Else
                                'つなぎめ以外
                                '配列に設定
                                setValueGOPPTS = nowValueGOPPTS - difValueGOPPTSBASE
                                'setPTStoArray(adpBytes, setValueGOPPTS - difValueGOPPTSBASE)
                                If &H1FFFFFFFFL < setValueGOPPTS Then
                                    setValueGOPPTS = nowValueGOPPTS - prevdifValueGOPPTSBASE
                                    setPTStoArray(adpBytes, setValueGOPPTS, c)
                                Else
                                    setPTStoArray(adpBytes, setValueGOPPTS, c)
                                End If
                                prevSetValueGOPPTS = setValueGOPPTS
                                'DTSの設定
                                'setDTStoArray(adpBytes, getValueDTS(adpBytes) - difValueGOPPTSBASE)
                                nowValueDTS = getValueDTS(adpBytes)
                                setValueDTS = nowValueDTS - difValueGOPPTSBASE
                                If &H1FFFFFFFFL < setValueDTS Then
                                    setDTStoArray(adpBytes, nowValueDTS - prevdifValueGOPPTSBASE, c)
                                Else
                                    setDTStoArray(adpBytes, setValueDTS, c)
                                End If
                            End If

                    End Select

                    '映像PTS
                ElseIf foundVideoPTS Then
                    'setPTStoArray(adpBytes, getValuePTS(adpBytes) - difValueGOPPTSBASE)
                    nowValuePTS = getValuePTS(adpBytes)
                    setValuePTS = nowValuePTS - difValueGOPPTSBASE
                    If &H1FFFFFFFFL < setValuePTS Then
                        setPTStoArray(adpBytes, nowValuePTS - prevdifValueGOPPTSBASE, c)
                    Else
                        setPTStoArray(adpBytes, setValuePTS, c)
                    End If
                End If

            End While
            If bForcedEnding Then
                Me.Invoke(WriteDataGridView2Instance, New Object() {c, ((nFilePoint * 100) \ rfs.Length).ToString + "%...強制終了"})
                Me.Invoke(WriteButton2TextInstance, New Object() {"終了"})
            Else
                Me.Invoke(WriteButton2TextInstance, New Object() {"100%"})
            End If

        Catch ex As System.Exception
            Me.Invoke(WriteDataGridView2Instance, New Object() {c, ex.Message})
            Throw
        Finally
            If Not rfs Is Nothing Then
                rfs.Close()
                rfs.Dispose()
            End If
            If Not ofs Is Nothing Then
                ofs.Close()
                ofs.Dispose()
            End If

        End Try

    End Sub

    Private Function getValuePCR() As Long
        Dim PCR As Long = (CLng(nVideo(nBuffPoint + 6)) * &H1000000 + CLng(nVideo(nBuffPoint + 7)) * &H10000 + CLng(nVideo(nBuffPoint + 8)) * &H100 + nVideo(nBuffPoint + 9)) * 2 + (nVideo(nBuffPoint + 10) And &H80) \ &H80
        PCR *= 300
        PCR += ((nVideo(nBuffPoint + 10) And 1) * &H100 + nVideo(nBuffPoint + 11))
        Return PCR

    End Function

    Private Function getValuePTS(ByVal adpBytes As Int32) As Long
        Dim PTS As Long = ((CLng(nVideo(nBuffPoint + adpBytes + 13)) And &HE) \ 2) * &H40000000 + CLng(nVideo(nBuffPoint + adpBytes + 14)) * &H400000 + ((CLng(nVideo(nBuffPoint + adpBytes + 15)) And &HFE) \ 2) * &H8000 + CLng(nVideo(nBuffPoint + adpBytes + 16)) * &H80 + CLng(nVideo(nBuffPoint + adpBytes + 17)) \ 2
        Return PTS

    End Function

    Private Function getValueDTS(ByVal adpBytes As Int32) As Long
        Dim DTS As Long = ((CLng(nVideo(nBuffPoint + adpBytes + 18)) And &HE) \ 2) * &H40000000 + CLng(nVideo(nBuffPoint + adpBytes + 19)) * &H400000 + ((CLng(nVideo(nBuffPoint + adpBytes + 20)) And &HFE) \ 2) * &H8000 + CLng(nVideo(nBuffPoint + adpBytes + 21)) * &H80 + CLng(nVideo(nBuffPoint + adpBytes + 22)) \ 2
        Return DTS

    End Function

    Private Sub setPCRtoArray(ByVal nValue As Long, ByVal c As Int32)
        Try
            nVideo(nBuffPoint + 10) = (nValue Mod 300) \ &H100
            nVideo(nBuffPoint + 11) = (nValue Mod 300) Mod &H100
            nValue \= 300
            nVideo(nBuffPoint + 10) = nVideo(nBuffPoint + 10) Or (nValue Mod 2)
            nValue \= 2
            nVideo(nBuffPoint + 9) = nValue Mod &H100
            nValue \= &H100
            nVideo(nBuffPoint + 8) = nValue Mod &H100
            nValue \= &H100
            nVideo(nBuffPoint + 7) = nValue Mod &H100
            nVideo(nBuffPoint + 6) = nValue \ &H100

        Catch ex As System.Exception
            Me.Invoke(WriteDataGridView2Instance, New Object() {c, ex.Message})
        End Try

    End Sub

    Private Sub setPTStoArray(ByVal adpBytes As Int32, ByVal nValue As Long, ByVal c As Int32)
        Try
            nVideo(nBuffPoint + adpBytes + 13) = (nVideo(nBuffPoint + adpBytes + 13) And &HF1) + (nValue \ &H40000000) * 2
            nValue = nValue Mod &H40000000
            nVideo(nBuffPoint + adpBytes + 14) = nValue \ &H400000
            nValue = nValue Mod &H400000
            nVideo(nBuffPoint + adpBytes + 15) = (nVideo(nBuffPoint + adpBytes + 15) And 1) + (nValue \ &H8000) * 2
            nValue = nValue Mod &H8000
            nVideo(nBuffPoint + adpBytes + 16) = nValue \ &H80
            nVideo(nBuffPoint + adpBytes + 17) = (nVideo(nBuffPoint + adpBytes + 17) And 1) + (nValue Mod &H80) * 2

        Catch ex As System.Exception
            Me.Invoke(WriteDataGridView2Instance, New Object() {c, ex.Message})
        End Try

    End Sub

    Private Sub setDTStoArray(ByVal adpBytes As Int32, ByVal nValue As Long, ByVal c As Int32)
        Try
            nVideo(nBuffPoint + adpBytes + 18) = (nVideo(nBuffPoint + adpBytes + 18) And &HF1) + (nValue \ &H40000000) * 2
            nValue = nValue Mod &H40000000
            nVideo(nBuffPoint + adpBytes + 19) = nValue \ &H400000
            nValue = nValue Mod &H400000
            nVideo(nBuffPoint + adpBytes + 20) = (nVideo(nBuffPoint + adpBytes + 20) And 1) + (nValue \ &H8000) * 2
            nValue = nValue Mod &H8000
            nVideo(nBuffPoint + adpBytes + 21) = nValue \ &H80
            nVideo(nBuffPoint + adpBytes + 22) = (nVideo(nBuffPoint + adpBytes + 22) And 1) + (nValue Mod &H80) * 2

        Catch ex As System.Exception
            Me.Invoke(WriteDataGridView2Instance, New Object() {c, ex.Message})
        End Try

    End Sub

    Private Sub setFilesFromDataGriedVew1()
        Dim fileI As String
        Dim fileO As String
        For i As Int32 = 0 To Me.DataGridView1.RowCount - 1
            fileI = Me.DataGridView1(0, i).Value
            If String.IsNullOrEmpty(fileI) Then Exit For

            fileO = dstPath
            If String.IsNullOrEmpty(dstPath) Then
                fileO = Path.GetDirectoryName(fileI)
            End If
            If Not (fileO.Substring(fileO.Length - 1, 1) = "\") Then fileO += "\"
            fileO += (Path.GetFileNameWithoutExtension(fileI) + ".000" + Path.GetExtension(fileI))
            Me.DataGridView2(0, i).Value = fileO
        Next

    End Sub

    Private Sub setFilesToDataGridView(ByVal i As Int32, ByVal fileI As String)
        Dim fileO As String
        Dim g As Graphics = Graphics.FromHwnd(Me.DataGridView1.Handle)
        Dim sf As New StringFormat()
        Dim ItemWidth As Int32

        If Path.GetExtension(fileI).ToLower = ".ts" Then
            Me.DataGridView1.RowCount += 1
            Me.DataGridView2.RowCount += 1
            Me.DataGridView1(0, i).Value = fileI
            ItemWidth = CInt(g.MeasureString(fileI, Me.DataGridView1.Font, Integer.MaxValue, sf).Width)
            If Me.DataGridView1.Columns(0).Width < ItemWidth Then Me.DataGridView1.Columns(0).Width = ItemWidth
            Me.DataGridView1(1, i).Value = System.IO.File.GetLastWriteTime(fileI)

            fileO = dstPath
            If String.IsNullOrEmpty(dstPath) Then
                fileO = Path.GetDirectoryName(fileI)
            End If
            If Not (fileO.Substring(fileO.Length - 1, 1) = "\") Then fileO += "\"
            fileO += (Path.GetFileNameWithoutExtension(fileI) + ".000" + Path.GetExtension(fileI))
            Me.DataGridView2(0, i).Value = fileO
            ItemWidth = CInt(g.MeasureString(fileO, Me.DataGridView2.Font, Integer.MaxValue, sf).Width)
            If Me.DataGridView2.Columns(0).Width < ItemWidth Then Me.DataGridView2.Columns(0).Width = ItemWidth
        End If

    End Sub

    Private Sub WriteButton2Text(ByVal Value As String)
        Button5.Text = Value

    End Sub

    Private Sub WriteDataGridView2(ByVal i As Int32, ByVal Value As String)
        DataGridView2(1, i).Value = Value

    End Sub

    Private Sub ForeColorDataGridView2(ByVal i As Int32, ByVal Value As System.Drawing.Color)
        DataGridView2(1, i).Style.ForeColor = Value

    End Sub

End Class

'IComparerインターフェイスを実装した、並び替える方法を定義したクラス
Public Class CustomComparer
    Implements IComparer
    Private sOrder As Integer
    Private comparer As Comparer

    Public Sub New(ByVal order As SortOrder)
        Me.sOrder = IIf(order = SortOrder.Descending, -1, 1)
        Me.comparer = New Comparer(System.Globalization.CultureInfo.CurrentCulture)

    End Sub

    '並び替え方を定義する
    Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer Implements System.Collections.IComparer.Compare
        Dim result As Integer = 0

        Dim rowx As DataGridViewRow = CType(x, DataGridViewRow)
        Dim rowy As DataGridViewRow = CType(y, DataGridViewRow)

        'はじめの列のセルの値を比較し、同じならば次の列を比較する
        For i As Integer = 0 To rowx.Cells.Count - 1
            result = Me.comparer.Compare(rowx.Cells(i).Value, rowy.Cells(i).Value)
            If result <> 0 Then
                Exit For
            End If
        Next i

        '結果を返す
        Return result * Me.sOrder

    End Function

End Class

<Serializable()> _
Public Class Settings
    Public srcPath As String
    Public dstPath As String
    Public PATChek As Boolean
End Class

