﻿
Imports System
Imports System.IO
Imports System.Threading

Module Module1
    Private PATChek As Boolean = True
    Private FileNameIN As String
    Private FileNameOUT As String
    Private rfs As FileStream
    Private ofs As FileStream
    Private nVideo(&H177FFF) As Byte     ' データ格納用配列188X8192
    Private nBuffPoint As Long
    Private nFilePoint As Long = 0
    Private readSize As Int32            ' Readメソッドで読み込んだバイト数
    Private bPAT As Boolean
    Private bPMT As Boolean
    Private bPCRPID As Boolean
    Private bVideoPID As Boolean
    Private bAudioPID As Boolean
    Private bGOP As Boolean
    Private PMT_PID As Int32
    Private PCR_PID As Int32
    Private Video_PID As Int32
    Private Audio_PID As Int32
    Private VideoStreamID As Int32
    Private AudioStreamID As Int32

    'PTSとPCRの同期 PTSが先にくる PCRはPTSより小さい
    'PTSをAM01:00:00からにPTS=324000000
    Private Const startVideoPTS = 324000000

    Sub Main()

        Dim cmds As String() = System.Environment.GetCommandLineArgs()
        Dim cmd As String
        Dim srcPath As String = ""
        Dim dstPath As String = ""
        Dim files As New List(Of String)

        If 1 = cmds.Length Then
            Console.WriteLine("使用法")
            Console.WriteLine("TsTimeKeeperC [-i:入力フォルダ] [-o:出力フォルダ] [-n] 入力ファイル名1 入力ファイル名2 ... ")
            Console.WriteLine("オプション [-i:] [-o:] [-n] の指定は、ファイル名の前後どちらでも可能です。")
            Console.WriteLine("例:TsTimeKeeperC [-i:e:\sourceFolder] [-o:f:\destFolder] [-n] sourceFile1.ts sourceFile2.ts ...")
            Console.WriteLine("　:TsTimeKeeperC e:\work\sourcefile1.ts e:\work\sourcefile2.ts")
            Console.WriteLine("オプションの指定内容")
            Console.WriteLine("  -i: 入力元フォルダ指定")
            Console.WriteLine("  -o: 出力先フォルダ指定")
            Console.WriteLine("  -n  PATテーブルを厳密にチェックしない(通常は指定しない)" + vbCrLf)
            Console.WriteLine("出力ファイル名は入力ファイル+000.ts")
            Console.WriteLine("例:e:\sourceFile1.ts → e:\sourceFile1.000.ts")
            Console.WriteLine(vbCrLf + "リターンキーを押してください")
            Console.Read()

            End
        Else
            Dim i As Int32 = 0
            For Each cmd In cmds
                If 0 < i Then
                    Select Case cmd.Substring(0, 2)
                        Case "-o"
                            dstPath = cmd.Substring(3)
                        Case "-i"
                            srcPath = cmd.Substring(3)
                        Case "-n"
                            PATChek = False
                        Case Else
                            files.Add(cmd)
                    End Select
                End If
                i += 1
            Next

            If Not String.IsNullOrEmpty(srcPath) AndAlso Not System.IO.Directory.Exists(srcPath) Then
                Console.WriteLine("入力フォルダ名が違います " + srcPath)
                End
            End If
            If Not String.IsNullOrEmpty(dstPath) AndAlso Not System.IO.Directory.Exists(dstPath) Then
                Console.WriteLine("出力フォルダ名が違います " + dstPath)
                End
            End If

            For i = 0 To files.Count - 1
                FileNameIN = files.Item(i)
                If Not String.IsNullOrEmpty(srcPath) Then
                    If Not (srcPath.Substring(srcPath.Length - 1, 1) = "\") Then srcPath += "\"
                    FileNameIN = srcPath + Path.GetFileName(FileNameIN)
                End If
                If Not System.IO.File.Exists(FileNameIN) OrElse Not Path.GetExtension(FileNameIN).ToLower = ".ts" Then
                    Console.WriteLine("入力ファイル名が違います" + FileNameIN)
                Else
                    If String.IsNullOrEmpty(dstPath) Then
                        FileNameOUT = Path.GetDirectoryName(FileNameIN)
                        If String.IsNullOrEmpty(FileNameOUT) Then
                            FileNameOUT = (Path.GetFileNameWithoutExtension(FileNameIN) + ".000" + Path.GetExtension(FileNameIN))
                        Else
                            If Not (FileNameOUT.Substring(FileNameOUT.Length - 1, 1) = "\") Then FileNameOUT += "\"
                            FileNameOUT += (Path.GetFileNameWithoutExtension(FileNameIN) + ".000" + Path.GetExtension(FileNameIN))
                        End If
                    Else
                        If Not (dstPath.Substring(dstPath.Length - 1, 1) = "\") Then dstPath += "\"
                        FileNameOUT = dstPath + Path.GetFileNameWithoutExtension(FileNameIN) + ".000" + Path.GetExtension(FileNameIN)
                    End If
                    '変更処理
                    TimeKeep()

                End If
            Next

        End If

    End Sub

    Public Sub TimeKeep()
        'FileからPCR_PID,Video_PID,Audio_PIDを得る
        Console.WriteLine("TsTimeKeeperC V2.0.10.3 - " + FileNameIN)
        Console.WriteLine("PAT,PMT,GOP 検索開始:" + TimeString)
        GetInfoFromFile()
        If (bPMT And bGOP) Or (bPCRPID AndAlso bVideoPID AndAlso bAudioPID AndAlso bGOP) Then
            Console.WriteLine(vbCr + "検索終了  ")
            'PMT or PCR_PID,Video_PID,Audio_PIDが取得できたら
            Console.WriteLine("PCR,PTS,DTS 変更開始")
            TimeKeepMain()
            Console.WriteLine(vbCr + "処理完了:" + TimeString)
        End If

    End Sub

    Private Sub GetInfoFromFile()
        Try
            Dim rfs = New FileStream(FileNameIN, FileMode.Open, FileAccess.Read)
            Dim adpBytes As Int32
            Dim nBuffPoint As Long = 0
            Dim listPMD_PID As New List(Of Int32)
            Dim listVideo_PID As New List(Of Int32)
            Dim listAudio_PID As New List(Of Int32)
            Dim x As Int32
            Dim streamID As Int32
            Dim bGOPFirst As Boolean = True
            Dim errMes As Int32 = 0

            bPAT = False
            bPMT = False
            bPCRPID = False
            bVideoPID = False
            bAudioPID = False
            bGOP = False
            VideoStreamID = -1
            AudioStreamID = -1

            listPMD_PID.Clear()
            listVideo_PID.Clear()
            listAudio_PID.Clear()

            nBuffPoint = -188
            nFilePoint = -188
            readSize = rfs.Read(nVideo, 0, nVideo.Length)

            Do While True
                System.Console.Write(vbCr + ((nFilePoint * 100) \ rfs.Length).ToString + "% 終了     ")
                System.Windows.Forms.Application.DoEvents()
                Do
                    nBuffPoint += 188
                    nFilePoint += 188
                    If readSize - 1 < nBuffPoint Then
                        '読込み
                        readSize = rfs.Read(nVideo, 0, nVideo.Length)
                        If 0 = readSize Then
                            Exit Do
                        End If
                        nBuffPoint = 0
                    End If

                    'プログラムPIDが"00"ならPAT(テーブル識別(00)+セクションシンタクス指示(1)+0+11ならPAT)
                    If bPAT = False Then
                        If 0 = (nVideo(nBuffPoint + 1) And &H1F) * &H100 + nVideo(nBuffPoint + 2) AndAlso &HB = nVideo(nBuffPoint + 5) * &H10 + (nVideo(nBuffPoint + 6) And &HF0) \ &H10 Then
                            Dim dataBytes As Int32 = (nVideo(nBuffPoint + 6) And &HF) * &H100 + nVideo(nBuffPoint + 7) - 9
                            Dim OffSet As Int32 = 0
                            Do While OffSet < dataBytes
                                If PATChek Then
                                    'If nVideo(nBuffPoint + OffSet + 13) * &H100 + nVideo(nBuffPoint + OffSet + 14) <> 0 AndAlso (nVideo(nBuffPoint + OffSet + 15) And &HE0) = &HE0 Then
                                    If (Not (nVideo(nBuffPoint + OffSet + 13) * &H100 + nVideo(nBuffPoint + OffSet + 14)).Equals(0)) AndAlso (nVideo(nBuffPoint + OffSet + 15) And &HE0) = &HE0 Then
                                        'PMT_PID = (nVideo(nBuffPoint + OffSet + 15) * &H100 + nVideo(nBuffPoint + OffSet + 16)) And &H1FFF
                                        If -1 = listPMD_PID.IndexOf((nVideo(nBuffPoint + OffSet + 15) * &H100 + nVideo(nBuffPoint + OffSet + 16)) And &H1FFF) Then
                                            listPMD_PID.Add((nVideo(nBuffPoint + OffSet + 15) * &H100 + nVideo(nBuffPoint + OffSet + 16)) And &H1FFF)
                                        End If
                                    End If
                                Else
                                    'If nVideo(nBuffPoint + OffSet + 13) * &H100 + nVideo(nBuffPoint + OffSet + 14) <> 0 AndAlso (nVideo(nBuffPoint + OffSet + 15) And &HE0) = &HE0 Then
                                    If Not (nVideo(nBuffPoint + OffSet + 13) * &H100 + nVideo(nBuffPoint + OffSet + 14)).Equals(0) Then
                                        'PMT_PID = (nVideo(nBuffPoint + OffSet + 15) * &H100 + nVideo(nBuffPoint + OffSet + 16)) And &H1FFF
                                        If -1 = listPMD_PID.IndexOf((nVideo(nBuffPoint + OffSet + 15) * &H100 + nVideo(nBuffPoint + OffSet + 16)) And &H1FFF) Then
                                            listPMD_PID.Add((nVideo(nBuffPoint + OffSet + 15) * &H100 + nVideo(nBuffPoint + OffSet + 16)) And &H1FFF)
                                        End If
                                    End If
                                End If
                                OffSet += 4
                            Loop
                            bPAT = True
                        End If
                    End If

                    If bPAT Then
                        Select Case listPMD_PID.Count
                            Case 0
                                errMes = 1
                                bPMT = False
                                Exit Do
                            Case 1
                                PMT_PID = listPMD_PID.Item(0)
                            Case Else
                                errMes = 3
                                bPMT = False
                                Exit Do
                        End Select
                    End If

                    ''プログラムPIDがPMT_PID テーブル識別(02)+セクションシンタクス指示(1)+0+11ならPMT
                    If bPMT = False Then
                        If PMT_PID = (nVideo(nBuffPoint + 1) And &H1F) * &H100 + nVideo(nBuffPoint + 2) AndAlso &H2B = nVideo(nBuffPoint + 5) * &H10 + (nVideo(nBuffPoint + 6) And &HF0) \ &H10 Then
                            PCR_PID = (nVideo(nBuffPoint + 13) And &H1F) * &H100 + nVideo(nBuffPoint + 14)
                            bPCRPID = True
                            Dim dataBytes As Int32 = (nVideo(nBuffPoint + 6) And &HF) * &H100 + nVideo(nBuffPoint + 7)
                            Dim offSet As Int32 = (nVideo(nBuffPoint + 15) And &HF) * &H100 + nVideo(nBuffPoint + 16) + 17
                            Do While offSet < dataBytes
                                Select Case nVideo(nBuffPoint + offSet) 'ストリーム形式識別
                                    Case 2      '映像
                                        'Video_PID = (nVideo(nBuffPoint + 1 + offSet) And &H1F) * &H100 + nVideo(nBuffPoint + 2 + offSet)
                                        If -1 = listVideo_PID.IndexOf((nVideo(nBuffPoint + 1 + offSet) And &H1F) * &H100 + nVideo(nBuffPoint + 2 + offSet)) Then
                                            listVideo_PID.Add((nVideo(nBuffPoint + 1 + offSet) And &H1F) * &H100 + nVideo(nBuffPoint + 2 + offSet))
                                        End If
                                    Case &HF    '音声
                                        'Audio_PID = (nVideo(nBuffPoint + 1 + offSet) And &H1F) * &H100 + nVideo(nBuffPoint + 2 + offSet)
                                        If -1 = listAudio_PID.IndexOf((nVideo(nBuffPoint + 1 + offSet) And &H1F) * &H100 + nVideo(nBuffPoint + 2 + offSet)) Then
                                            listAudio_PID.Add((nVideo(nBuffPoint + 1 + offSet) And &H1F) * &H100 + nVideo(nBuffPoint + 2 + offSet))
                                        End If
                                End Select
                                offSet += ((nVideo(nBuffPoint + 3 + offSet) And &HF) * &H100 + nVideo(nBuffPoint + 4 + offSet) + 5)
                            Loop
                            bPMT = True
                            Exit Do
                        End If
                    End If

                    'GOP,VideoPID
                    If nVideo(nBuffPoint) = &H47 Then
                        If 0 < (nVideo(nBuffPoint + 3) And &H10) Then                       'payload exists
                            adpBytes = 0
                            'アダプテーションが入ってるパケットか
                            If (nVideo(nBuffPoint + 3) And &H20) Then
                                adpBytes = nVideo(nBuffPoint + 4) + 1
                            End If
                            'パケットスタートコード(000001)
                            If nVideo(nBuffPoint + adpBytes + 4) = 0 AndAlso nVideo(nBuffPoint + adpBytes + 5) = 0 AndAlso nVideo(nBuffPoint + adpBytes + 6) = 1 AndAlso (nVideo(nBuffPoint + adpBytes + 10) And &HC0) = &H80 Then
                                If 0 < (nVideo(nBuffPoint + adpBytes + 11) And &HC0) Then   'PTS=&H80 DTS=&H40
                                    x = nVideo(nBuffPoint + adpBytes + 13) And &HF0
                                    If x = &H20 Or x = &H30 Then                            'PTS +DTS
                                        x = nVideo(nBuffPoint + adpBytes + 7)               'streamID
                                        streamID = x And &HF
                                        If (x And &HF0) = &HE0 Then
                                            '映像
                                            If VideoStreamID = -1 Then
                                                VideoStreamID = streamID
                                            End If
                                            If VideoStreamID = streamID Then
                                                'Video_PID = (nVideo(nBuffPoint + 1) And &H1F) * &H100 + nVideo(nBuffPoint + 2)
                                                If -1 = listVideo_PID.IndexOf((nVideo(nBuffPoint + 1) And &H1F) * &H100 + nVideo(nBuffPoint + 2)) Then
                                                    listVideo_PID.Add((nVideo(nBuffPoint + 1) And &H1F) * &H100 + nVideo(nBuffPoint + 2))
                                                End If
                                                bVideoPID = True
                                                If 0 < (nVideo(nBuffPoint + adpBytes + 11) And &H40) Then
                                                    bGOP = True
                                                End If
                                                If bGOP = False Then
                                                    bGOPFirst = False
                                                End If
                                                Exit Do
                                            End If
                                        End If
                                    End If
                                End If
                            End If
                        End If
                    End If

                    'Audio_PID
                    If nVideo(nBuffPoint) = &H47 Then
                        If 0 < (nVideo(nBuffPoint + 3) And &H10) Then           'payload exists
                            'アダプテーションが入ってるパケットか
                            adpBytes = 0
                            If (nVideo(nBuffPoint + 3) And &H20) Then
                                adpBytes = nVideo(nBuffPoint + 4) + 1
                            End If
                            'パケットスタートコード(000001)
                            If nVideo(nBuffPoint + adpBytes + 4) = 0 AndAlso nVideo(nBuffPoint + adpBytes + 5) = 0 AndAlso nVideo(nBuffPoint + adpBytes + 6) = 1 AndAlso (nVideo(nBuffPoint + adpBytes + 10) And &HC0) = &H80 Then
                                x = nVideo(nBuffPoint + adpBytes + 7)   'streamID
                                streamID = x And &H1F
                                If (x And &HE0) = &HC0 Then
                                    '音声
                                    If AudioStreamID = -1 Then
                                        AudioStreamID = streamID
                                    End If
                                    If AudioStreamID = streamID Then
                                        ''Audio_PID = (nVideo(nBuffPoint + 1) And &H1F) * &H100 + nVideo(nBuffPoint + 2)
                                        If -1 = listAudio_PID.IndexOf((nVideo(nBuffPoint + 1) And &H1F) * &H100 + nVideo(nBuffPoint + 2)) Then
                                            listAudio_PID.Add((nVideo(nBuffPoint + 1) And &H1F) * &H100 + nVideo(nBuffPoint + 2))
                                        End If
                                        bAudioPID = True
                                        If bGOP = False Then
                                            bGOPFirst = False
                                        End If
                                        Exit Do
                                    End If
                                End If
                            End If
                        End If
                    End If
                Loop While True

                If 0 < errMes Then Exit Do

                If bPAT AndAlso bPMT AndAlso bGOP AndAlso Not VideoStreamID.Equals(-1) AndAlso Not AudioStreamID.Equals(-1) Then
                    If bGOP And bGOPFirst = False Then
                        errMes = 2
                        bGOP = False
                        Exit Do
                    End If
                    Select Case listVideo_PID.Count
                        Case 0
                            errMes = 1
                            bVideoPID = False
                            Exit Do
                        Case 1
                            Video_PID = listVideo_PID.Item(0)
                        Case Else
                            errMes = 3
                            bVideoPID = False
                            Exit Do
                    End Select
                    Select Case listAudio_PID.Count
                        Case 0
                            errMes = 1
                            bAudioPID = False
                            Exit Do
                        Case 1
                            Audio_PID = listAudio_PID.Item(0)
                        Case Else
                            errMes = 3
                            bAudioPID = False
                            Exit Do
                    End Select
                    Exit Do
                End If
                If readSize = 0 Then Exit Do
                If 188 * 32768 < nFilePoint Then '188 * 32768←根拠無し
                    errMes = 3
                    Exit Do
                End If
            Loop

            Select Case errMes
                Case 0
                    System.Console.Write(vbCr + "100% 終了     ")
                Case 1
                    System.Console.WriteLine("ファイルが破損している可能性があります...終了します" + vbCrLf)
                Case 2
                    System.Console.WriteLine("ファイルの先頭がGOPで区切られていません...終了します" + vbCrLf)
                Case 3
                    System.Console.WriteLine("複数の映像が含まれています...処理できません" + vbCrLf)
            End Select

        Catch ex As System.Exception
            System.Console.WriteLine(ex.Message)
            Throw
        Finally
            If Not rfs Is Nothing Then
                rfs.Close()
                rfs.Dispose()
            End If

        End Try

    End Sub

    Private Sub TimeKeepMain()
        Dim adpBytes As Int32
        Dim foundVideoPTS As Boolean
        Dim foundGOP As Boolean
        Dim numGOP As Long = 0
        Dim nowValuePCR As Long
        Dim setValuePCR As Long
        Dim prevValueGOPPTS As Long
        Dim nowValueGOPPTS As Long
        Dim setValueGOPPTS As Long
        Dim nowValuePTS As Long
        Dim setValuePTS As Long
        Dim nowValueDTS As Long
        Dim setValueDTS As Long
        Dim prevSetValueGOPPTS As Long
        Dim difValueGOPPTSBASE As Long
        Dim prevdifValueGOPPTSBASE As Long
        Dim difValueGOPPTS As Long
        Dim streamID As Int32
        Dim x As Int32

        Try
            rfs = New FileStream(FileNameIN, FileMode.Open, FileAccess.Read)
            ofs = New FileStream(FileNameOUT, FileMode.Create, FileAccess.Write)

            nBuffPoint = -188
            nFilePoint = -188
            '読込み
            readSize = rfs.Read(nVideo, 0, nVideo.Length)

            While True
                Console.Write(vbCr + ((nFilePoint * 100) \ rfs.Length).ToString + "% 終了     ")
                System.Windows.Forms.Application.DoEvents()
                Do
                    System.Windows.Forms.Application.DoEvents()
                    nBuffPoint += 188
                    nFilePoint += 188
                    If readSize - 1 < nBuffPoint Then
                        '書込み
                        ofs.Write(nVideo, 0, readSize)
                        '読込み
                        readSize = rfs.Read(nVideo, 0, nVideo.Length)
                        If 0 = readSize Then
                            rfs.Close()
                            ofs.Close()
                            rfs.Dispose()
                            ofs.Dispose()
                            System.Console.Write(vbCr + "100% 終了     ")
                            Exit Sub
                        End If
                        nBuffPoint = 0
                    End If

                    foundGOP = False
                    foundVideoPTS = False

                    'PCR
                    'If nVideo(nBuffPoint) = &H47 Then
                    'adaptation field exists
                    If 0 < (nVideo(nBuffPoint + 3) And &H20) Then
                        'PCR flag
                        If 0 < (nVideo(nBuffPoint + 5) And &H10) Then
                            x = nVideo(nBuffPoint + 1) And &HE0
                            If x = 0 Or x = &H20 Then
                                If (nVideo(nBuffPoint + 1) And &H1F) * &H100 + nVideo(nBuffPoint + 2) = PCR_PID Then
                                    'PCR設定
                                    'setPCRtoArray(getValuePCR() - difValueGOPPTSBASE * 300)
                                    nowValuePCR = getValuePCR()
                                    setValuePCR = nowValuePCR - difValueGOPPTSBASE * 300
                                    If &H258000000D3L < setValuePCR Then
                                        '&H1FFFFFFFF*&H12C+&H1FF=&H258000000D3
                                        setPCRtoArray(nowValuePCR - prevdifValueGOPPTSBASE * 300)
                                    Else
                                        setPCRtoArray(setValuePCR)
                                    End If
                                    Exit Do
                                End If
                            End If
                        End If
                    End If
                    'End If

                    '映像PST(GOP)
                    '(nBuffPoint+1)=&H40 payload start 1:Payload starts with first byte of PES Packet
                    '                                  0:No PES Packets in payload 
                    'If nVideo(nBuffPoint) = &H47 Then
                    If (nVideo(nBuffPoint + 1) And &H1F) * &H100 + nVideo(nBuffPoint + 2) = Video_PID Then
                        If 0 < (nVideo(nBuffPoint + 3) And &H10) Then                       'payload exists
                            adpBytes = 0
                            'アダプテーションが入ってるパケットか
                            If (nVideo(nBuffPoint + 3) And &H20) Then
                                adpBytes = nVideo(nBuffPoint + 4) + 1
                            End If
                            'パケットスタートコード(000001)
                            If nVideo(nBuffPoint + adpBytes + 4) = 0 AndAlso nVideo(nBuffPoint + adpBytes + 5) = 0 AndAlso nVideo(nBuffPoint + adpBytes + 6) = 1 AndAlso (nVideo(nBuffPoint + adpBytes + 10) And &HC0) = &H80 Then
                                If 0 < (nVideo(nBuffPoint + adpBytes + 11) And &H80) Then   'PTS=&H80 DTS=&H40
                                    x = nVideo(nBuffPoint + adpBytes + 13) And &HF0
                                    If x = &H20 Or x = &H30 Then                            'PTS +DTS
                                        x = nVideo(nBuffPoint + adpBytes + 7)               'streamID
                                        streamID = x And &H1F
                                        If (x And &HF0) = &HE0 Then
                                            '映像
                                            If VideoStreamID = streamID Then
                                                foundVideoPTS = True
                                                If 0 < (nVideo(nBuffPoint + adpBytes + 11) And &H40) Then
                                                    foundGOP = True
                                                    numGOP += 1
                                                End If
                                                Exit Do
                                            End If
                                        End If
                                    End If
                                End If
                            End If
                        End If
                    End If
                    'End If

                    '音声PTS
                    'If nVideo(nBuffPoint) = &H47 Then
                    If (nVideo(nBuffPoint + 1) And &H1F) * &H100 + nVideo(nBuffPoint + 2) = Audio_PID Then
                        adpBytes = 0
                        'アダプテーションが入ってるパケットか
                        If (nVideo(nBuffPoint + 3) And &H20) Then
                            adpBytes = nVideo(nBuffPoint + 4) + 1
                        End If
                        'パケットスタートコード(000001)
                        If nVideo(nBuffPoint + adpBytes + 4) = 0 AndAlso nVideo(nBuffPoint + adpBytes + 5) = 0 AndAlso nVideo(nBuffPoint + adpBytes + 6) = 1 AndAlso (nVideo(nBuffPoint + adpBytes + 10) And &HC0) = &H80 Then
                            x = nVideo(nBuffPoint + adpBytes + 7)   'streamID
                            streamID = x And &H1F
                            If (x And &HE0) = &HC0 Then
                                '音声
                                If AudioStreamID = streamID Then
                                    '音声PTS設定
                                    'setPTStoArray(adpBytes, getValuePTS(adpBytes) - difValueGOPPTSBASE)
                                    nowValuePTS = getValuePTS(adpBytes)
                                    setValuePTS = nowValuePTS - difValueGOPPTSBASE
                                    If &H1FFFFFFFFL < setValuePTS Then
                                        setPTStoArray(adpBytes, nowValuePTS - prevdifValueGOPPTSBASE)
                                    Else
                                        setPTStoArray(adpBytes, setValuePTS)
                                    End If
                                    Exit Do
                                End If
                            End If
                        End If
                    End If
                    'End If

                Loop While True

                'PTSの処理(GOP)
                If foundGOP Then
                    Select Case numGOP
                        Case 1 'GOP(PTS)の先頭
                            nowValueGOPPTS = getValuePTS(adpBytes)
                            difValueGOPPTSBASE = nowValueGOPPTS - startVideoPTS
                            prevdifValueGOPPTSBASE = difValueGOPPTSBASE
                            setValueGOPPTS = nowValueGOPPTS - difValueGOPPTSBASE
                            '配列に設定
                            setPTStoArray(adpBytes, setValueGOPPTS)
                            prevSetValueGOPPTS = setValueGOPPTS
                            'DTSの設定
                            setDTStoArray(adpBytes, getValueDTS(adpBytes) - difValueGOPPTSBASE)

                        Case Else
                            prevValueGOPPTS = nowValueGOPPTS
                            nowValueGOPPTS = getValuePTS(adpBytes)
                            difValueGOPPTS = nowValueGOPPTS - prevValueGOPPTS
                            If difValueGOPPTS < 0 Then                          'ラップアラウンド
                                prevValueGOPPTS = prevValueGOPPTS - &H1FFFFFFFFL
                                difValueGOPPTSBASE = difValueGOPPTSBASE - &H1FFFFFFFFL
                            End If
                            'PTSは90kHzのカウンタなので90000で1秒
                            If 900000 < difValueGOPPTS Then                     'つなぎ目
                                'つなぎめのすぐ後ろのPTS(現在位置)
                                'つなぎ目なので100ms(9009)固定とした
                                setValueGOPPTS = prevSetValueGOPPTS + 9009
                                difValueGOPPTSBASE = nowValueGOPPTS - setValueGOPPTS
                                prevdifValueGOPPTSBASE = difValueGOPPTSBASE
                                setPTStoArray(adpBytes, setValueGOPPTS)
                                prevSetValueGOPPTS = setValueGOPPTS
                                'DTSの設定
                                'setDTStoArray(adpBytes, getValueDTS(adpBytes) - difValueGOPPTSBASE)
                                nowValueDTS = getValueDTS(adpBytes)
                                setValueDTS = nowValueDTS - difValueGOPPTSBASE
                                If &H1FFFFFFFFL < setValueDTS Then
                                    setDTStoArray(adpBytes, nowValueDTS - prevdifValueGOPPTSBASE)
                                Else
                                    setDTStoArray(adpBytes, setValueDTS)
                                End If
                            Else                                                'つなぎめ以外
                                '配列に設定
                                setValueGOPPTS = nowValueGOPPTS - difValueGOPPTSBASE
                                'setPTStoArray(adpBytes, setValueGOPPTS)
                                If &H1FFFFFFFFL < setValueGOPPTS Then
                                    setValueGOPPTS = nowValueGOPPTS - prevdifValueGOPPTSBASE
                                    setPTStoArray(adpBytes, setValueGOPPTS)
                                Else
                                    setPTStoArray(adpBytes, setValueGOPPTS)
                                End If
                                prevSetValueGOPPTS = setValueGOPPTS
                                'DTSの設定
                                'setDTStoArray(adpBytes, getValueDTS(adpBytes) - difValueGOPPTSBASE)
                                nowValueDTS = getValueDTS(adpBytes)
                                setValueDTS = nowValueDTS - difValueGOPPTSBASE
                                If &H1FFFFFFFFL < setValueDTS Then
                                    setDTStoArray(adpBytes, nowValueDTS - prevdifValueGOPPTSBASE)
                                Else
                                    setDTStoArray(adpBytes, setValueDTS)
                                End If
                            End If

                    End Select

                    '映像PTS
                ElseIf foundVideoPTS Then
                    'setPTStoArray(adpBytes, getValuePTS(adpBytes) - difValueGOPPTSBASE)
                    nowValuePTS = getValuePTS(adpBytes)
                    setValuePTS = nowValuePTS - difValueGOPPTSBASE
                    If &H1FFFFFFFFL < setValuePTS Then
                        setPTStoArray(adpBytes, nowValuePTS - prevdifValueGOPPTSBASE)
                    Else
                        setPTStoArray(adpBytes, setValuePTS)
                    End If
                End If

            End While

        Catch ex As System.Exception
            System.Console.WriteLine(ex.Message)
            Throw
        Finally
            If Not rfs Is Nothing Then
                rfs.Close()
                rfs.Dispose()
            End If
            If Not ofs Is Nothing Then
                ofs.Close()
                ofs.Dispose()
            End If

        End Try

    End Sub

    Private Function getValuePCR() As Long
        Dim PCR = (CLng(nVideo(nBuffPoint + 6)) * &H1000000 + CLng(nVideo(nBuffPoint + 7)) * &H10000 + CLng(nVideo(nBuffPoint + 8)) * &H100 + nVideo(nBuffPoint + 9)) * 2 + (nVideo(nBuffPoint + 10) And &H80) \ &H80
        PCR *= 300
        PCR += ((nVideo(nBuffPoint + 10) And 1) * &H100 + nVideo(nBuffPoint + 11))
        Return PCR

    End Function

    Private Function getValuePTS(ByVal adpBytes As Int32) As Long
        Dim PTS As Long = ((CLng(nVideo(nBuffPoint + adpBytes + 13)) And &HE) \ 2) * &H40000000 + CLng(nVideo(nBuffPoint + adpBytes + 14)) * &H400000 + ((CLng(nVideo(nBuffPoint + adpBytes + 15)) And &HFE) \ 2) * &H8000 + CLng(nVideo(nBuffPoint + adpBytes + 16)) * &H80 + CLng(nVideo(nBuffPoint + adpBytes + 17)) \ 2
        Return PTS

    End Function

    Private Function getValueDTS(ByVal adpBytes As Int32) As Long
        Dim DTS As Long = ((CLng(nVideo(nBuffPoint + adpBytes + 18)) And &HE) \ 2) * &H40000000 + CLng(nVideo(nBuffPoint + adpBytes + 19)) * &H400000 + ((CLng(nVideo(nBuffPoint + adpBytes + 20)) And &HFE) \ 2) * &H8000 + CLng(nVideo(nBuffPoint + adpBytes + 21)) * &H80 + CLng(nVideo(nBuffPoint + adpBytes + 22)) \ 2
        Return DTS

    End Function

    Private Sub setPCRtoArray(ByVal nValue As Long)
        Try
            nVideo(nBuffPoint + 10) = (nValue Mod 300) \ &H100
            nVideo(nBuffPoint + 11) = (nValue Mod 300) Mod &H100
            nValue \= 300
            nVideo(nBuffPoint + 10) = nVideo(nBuffPoint + 10) Or (nValue Mod 2)
            nValue \= 2
            nVideo(nBuffPoint + 9) = nValue Mod &H100
            nValue \= &H100
            nVideo(nBuffPoint + 8) = nValue Mod &H100
            nValue \= &H100
            nVideo(nBuffPoint + 7) = nValue Mod &H100
            nVideo(nBuffPoint + 6) = nValue \ &H100
        Catch ex As System.Exception
            System.Console.WriteLine(ex.Message)
            Throw
        End Try
    End Sub

    Private Sub setPTStoArray(ByVal adpBytes As Int32, ByVal nValue As Long)
        Try
            nVideo(nBuffPoint + adpBytes + 13) = (nVideo(nBuffPoint + adpBytes + 13) And &HF1) + (nValue \ &H40000000) * 2
            nValue = nValue Mod &H40000000
            nVideo(nBuffPoint + adpBytes + 14) = nValue \ &H400000
            nValue = nValue Mod &H400000
            nVideo(nBuffPoint + adpBytes + 15) = (nVideo(nBuffPoint + adpBytes + 15) And 1) + (nValue \ &H8000) * 2
            nValue = nValue Mod &H8000
            nVideo(nBuffPoint + adpBytes + 16) = nValue \ &H80
            nVideo(nBuffPoint + adpBytes + 17) = (nVideo(nBuffPoint + adpBytes + 17) And 1) + (nValue Mod &H80) * 2
        Catch ex As System.Exception
            System.Console.WriteLine(ex.Message)
            Throw
        End Try

    End Sub

    Private Sub setDTStoArray(ByVal adpBytes As Int32, ByVal nValue As Long)
        Try
            nVideo(nBuffPoint + adpBytes + 18) = (nVideo(nBuffPoint + adpBytes + 18) And &HF1) + (nValue \ &H40000000) * 2
            nValue = nValue Mod &H40000000
            nVideo(nBuffPoint + adpBytes + 19) = nValue \ &H400000
            nValue = nValue Mod &H400000
            nVideo(nBuffPoint + adpBytes + 20) = (nVideo(nBuffPoint + adpBytes + 20) And 1) + (nValue \ &H8000) * 2
            nValue = nValue Mod &H8000
            nVideo(nBuffPoint + adpBytes + 21) = nValue \ &H80
            nVideo(nBuffPoint + adpBytes + 22) = (nVideo(nBuffPoint + adpBytes + 22) And 1) + (nValue Mod &H80) * 2
        Catch ex As System.Exception
            System.Console.WriteLine(ex.Message)
            Throw
        End Try

    End Sub

End Module
